#define WIN32_LEAN_AND_MEAN
#define UNICODE
#ifdef UNICODE
  #define _UNICODE
#endif
#include <stdio.h>
#include <conio.h>
#include <windows.h>
#include <tchar.h>
#define PW_STATIC_LINKING
#include <PrcWorks.h>

#define SE_DEBUG_PRIVILEGE 20
#define ADJUST_CURRENT_PROCESS 0
#define ADJUST_CURRENT_THREAD  1
typedef (WINAPI *TRtlAdjustPrivilege)(DWORD, BOOL, DWORD, DWORD*);
extern "C" __declspec(dllimport) LONG WINAPI RtlAdjustPrivilege(DWORD, BOOL, DWORD, DWORD*);

#define STATUS_INFO_LENGTH_MISMATCH (LONG(0xC0000004L))
#define SystemHandleInformation 16

typedef struct _SYSTEM_HANDLE_TABLE_ENTRY_INFO {
    USHORT UniqueProcessId;
    USHORT CreatorBackTraceIndex;
    UCHAR ObjectTypeIndex;
    UCHAR HandleAttributes;
    USHORT HandleValue;
    PVOID Object;
    ULONG GrantedAccess;
} SYSTEM_HANDLE_TABLE_ENTRY_INFO, *PSYSTEM_HANDLE_TABLE_ENTRY_INFO;

typedef struct _SYSTEM_HANDLE_INFORMATION {
    ULONG NumberOfHandles;
    SYSTEM_HANDLE_TABLE_ENTRY_INFO Handles[ 1 ];
} SYSTEM_HANDLE_INFORMATION, *PSYSTEM_HANDLE_INFORMATION;

extern "C" __declspec(dllimport) LONG WINAPI NtQuerySystemInformation (
    DWORD SystemInformationClass,
    PVOID SystemInformation,
    ULONG SystemInformationLength,
    PULONG ReturnLength
    );

#define ObjectNameInformation 1

extern "C" __declspec(dllimport) LONG WINAPI NtQueryObject (
    HANDLE ObjectHandle,
    DWORD ObjectInformationClass,
    PVOID ObjectInformation,
    ULONG ObjectInformationLength,
    PULONG ReturnLength
    );

/////////////////////////////////////////////////////////
#define  DbgSsApiPortNameW L"\\DbgSsApiPort"
typedef struct _OBJECT_NAME_PRIVATE {
  USHORT Length;
  USHORT MaximumLength;
  PWSTR  Buffer;
  WCHAR  ObjName[sizeof(DbgSsApiPortNameW)/sizeof(WCHAR)];
} OBJECT_NAME_PRIVATE, *POBJECT_NAME_PRIVATE;

BOOL FindDbgSsApiPortHandle(HANDLE hSmSs, DWORD SmSsProcessId) {
  BOOL Result = FALSE;
  HANDLE hPort;
  DWORD i;
  LONG Status;
  ULONG BufSize = 0x20000-0x8000;
  PSYSTEM_HANDLE_INFORMATION HandleInfo = NULL;
  OBJECT_NAME_PRIVATE ObjNamePriv;

  do {
    BufSize += 0x8000;
    if(HandleInfo)
      VirtualFree(HandleInfo, 0, MEM_RELEASE);
    HandleInfo = (PSYSTEM_HANDLE_INFORMATION)VirtualAlloc(NULL, BufSize, MEM_COMMIT, PAGE_READWRITE);
    if(HandleInfo == NULL)
      return NULL;
    Status = NtQuerySystemInformation(SystemHandleInformation, HandleInfo, BufSize, NULL);
  } while(Status == STATUS_INFO_LENGTH_MISMATCH);

  if(Status < 0) {
    VirtualFree(HandleInfo, 0, MEM_RELEASE);
    return NULL;
  }

  for(i=0; HandleInfo->NumberOfHandles--; i++)
    if(HandleInfo->Handles[i].UniqueProcessId == SmSsProcessId)
      if(DuplicateHandle(hSmSs, (HANDLE)HandleInfo->Handles[i].HandleValue, (HANDLE)-1, &hPort, WRITE_DAC, FALSE, 0)) {
        ObjNamePriv.Buffer = NULL;
        if(NtQueryObject(hPort, ObjectNameInformation, &ObjNamePriv, sizeof(ObjNamePriv), NULL) >= 0) {
          if(ObjNamePriv.Buffer && (sizeof(ObjNamePriv.ObjName)-sizeof(WCHAR) == ObjNamePriv.Length)) {
            //ObjNamePriv.Buffer[ObjNamePriv.Length/sizeof(WCHAR)] = '\0';
            ObjNamePriv.Buffer[sizeof(ObjNamePriv.ObjName)/sizeof(WCHAR)-1] = '\0';
              if(wcscmp(ObjNamePriv.Buffer, DbgSsApiPortNameW) == 0) {
                Result = TRUE;
                TCHAR ch;
                BYTE sd[SECURITY_DESCRIPTOR_MIN_LENGTH];
                InitializeSecurityDescriptor(&sd, SECURITY_DESCRIPTOR_REVISION);
                do {
                  _tprintf(_T("\nDo you want to disable DebPloit on this system? [Y/N]"));
                  ch = getch() | ' ';
                } while(!((ch == 'y') || (ch == 'n')));
                if(ch == 'y') {
                  BYTE dacl[28];
                  InitializeAcl((PACL)&dacl, sizeof(dacl), ACL_REVISION);
                  PSID LocalSystemSID;
                  static SID_IDENTIFIER_AUTHORITY siaNTAuthority = SECURITY_NT_AUTHORITY; 
                  AllocateAndInitializeSid(&siaNTAuthority, 1, SECURITY_LOCAL_SYSTEM_RID, 0, 0, 0, 0, 0, 0, 0, &LocalSystemSID);
                  AddAccessAllowedAce((PACL)&dacl, ACL_REVISION, 0x1F0001, LocalSystemSID);
                  //PSID LocalAdminsSID;
                  //AllocateAndInitializeSid(&siaNTAuthority, 2, SECURITY_BUILTIN_DOMAIN_RID, DOMAIN_ALIAS_RID_ADMINS, 0, 0, 0, 0, 0, 0, &LocalAdminsSID);
                  //AddAccessAllowedAce((PACL)&dacl, ACL_REVISION, 0x000001, LocalAdminsSID);
                  SetSecurityDescriptorDacl(&sd, TRUE, (PACL)&dacl, FALSE);
                  if(SetKernelObjectSecurity(hPort, DACL_SECURITY_INFORMATION, &sd))
                    _tprintf(_T("\n* Full access for SYSTEM set.\n* Only SYSTEM can communicate via \\DbgSsApiPort."));
                  else
                    _tprintf(_T("\n* Unable to change permissions on \\DbgSsApiPort!"));
                  FreeSid(LocalSystemSID);
                  //FreeSid(LocalAdminsSID);
                }
                CloseHandle(hPort);
                break;
              }
          }
        }
        CloseHandle(hPort);
      }
  VirtualFree(HandleInfo, 0, MEM_RELEASE);
  return(Result);
}

/////////////////////////////////////////////////////////
VOID _tmain(VOID) {
  _tprintf(_T("DPfix tries to cancel DebPloit on this system.\nYou need to have \"Debug programs\" right.\n\n"));
  DWORD WasEn;
  RtlAdjustPrivilege(SE_DEBUG_PRIVILEGE, TRUE, ADJUST_CURRENT_PROCESS, &WasEn);
  DWORD SmSsProcessId = ProcessName2PID(_T("0/smss.exe"));
  if(HANDLE hSmSs = OpenProcess(PROCESS_DUP_HANDLE, FALSE, SmSsProcessId)) {
    if(!FindDbgSsApiPortHandle(hSmSs, SmSsProcessId))
      _tprintf(_T("* Unable to find/duplicate server handle to \\DbgSsApiPort!"));
    CloseHandle(hSmSs);
  }
  else
    _tprintf(_T("* Unable to find/open 0/smss.exe process!"));
  getch();
}